Loading...
Searching...
No Matches
juce::PixelRGB Class Reference

## Detailed Description

Represents a 24-bit RGB pixel, and can perform compositing operations on it.

This is used internally by the imaging classes.

See also
  PixelARGB

The documentation for this class was generated from the following file:

- juce_graphics/colour/juce_PixelFormats.h

## Public Types

enum | { indexR = 0 , indexG = 1 , indexB = 2 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions

| PixelRGB () noexcept=default
| Creates a pixel without defining its colour.
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b.
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them.
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them.
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel>
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one.
void | setARGB (uint8, uint8 red, uint8 green, uint8 blue) noexcept
| Sets the pixel's colour from individual components.
template<class Pixel>
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one.
forcedinline void | blend (PixelRGB src) noexcept
template<class Pixel>
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity.
template<class Pixel>
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.
forcedinline void | setAlpha (uint8) noexcept
| This method is included for compatibility with the PixelARGB class.
forcedinline void | multiplyAlpha (int) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | multiplyAlpha (float) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha.
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values.
forcedinline void | desaturate () noexcept

## Member Enums

## anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexR |
indexG |
indexB |

## Constructors and Destructors

## PixelRGB()

juce::PixelRGB::PixelRGB | ( |  | ) |

default noexcept

Creates a pixel without defining its colour.

Referenced by blend().

## Member Functions

## getNativeARGB()

forcedinline uint32 juce::PixelRGB::getNativeARGB | ( |  | ) | const

inline noexcept

Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.

See also
  PixelARGB::getNativeARGB

References forcedinline, and getNativeARGB().

Referenced by getInARGBMaskOrder(), and getNativeARGB().

## getInARGBMaskOrder()

forcedinline uint32 juce::PixelRGB::getInARGBMaskOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

References forcedinline, and getNativeARGB().

Referenced by getInARGBMemoryOrder().

## getInARGBMemoryOrder()

uint32 juce::PixelRGB::getInARGBMemoryOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

References getInARGBMaskOrder().

## getEvenBytes()

forcedinline uint32 juce::PixelRGB::getEvenBytes | ( |  | ) | const

inline noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getEvenBytes of the PixelARGB class.

See also
  PixelARGB::getEvenBytes

References forcedinline.

Referenced by blend(), blend(), and tween().

## getOddBytes()

forcedinline uint32 juce::PixelRGB::getOddBytes | ( |  | ) | const

inline noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getOddBytes of the PixelARGB class.

See also
  PixelARGB::getOddBytes

References forcedinline.

Referenced by tween().

## getAlpha()

forcedinline uint8 juce::PixelRGB::getAlpha | ( |  | ) | const

inline noexcept

References forcedinline.

## getRed()

forcedinline uint8 juce::PixelRGB::getRed | ( |  | ) | const

inline noexcept

References forcedinline.

## getGreen()

forcedinline uint8 juce::PixelRGB::getGreen | ( |  | ) | const

inline noexcept

References forcedinline.

## getBlue()

forcedinline uint8 juce::PixelRGB::getBlue | ( |  | ) | const

inline noexcept

References forcedinline.

## set()

template<class Pixel>

forcedinline void juce::PixelRGB::set | ( | const Pixel & | src | ) |

inline noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one. Because PixelRGB has no alpha channel, any alpha value in the source pixel is thrown away.

References forcedinline.

Referenced by blend().

## setARGB()

void juce::PixelRGB::setARGB | ( | uint8 | ,
|  | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue )

inline noexcept

Sets the pixel's colour from individual components.

## blend() [1/3]

template<class Pixel>

forcedinline void juce::PixelRGB::blend | ( | const Pixel & | src | ) |

inline noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References juce::clampPixelComponents(), forcedinline, getEvenBytes(), and juce::maskPixelComponents().

## blend() [2/3]

forcedinline void juce::PixelRGB::blend | ( | PixelRGB | src | ) |

inline noexcept

References forcedinline, PixelRGB(), and set().

## blend() [3/3]

template<class Pixel>

forcedinline void juce::PixelRGB::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha )

inline noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

References juce::clampPixelComponents(), forcedinline, getEvenBytes(), and juce::maskPixelComponents().

## tween()

template<class Pixel>

forcedinline void juce::PixelRGB::tween | ( | const Pixel & | src,
|  | uint32 | amount )

inline noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

References forcedinline, getEvenBytes(), and getOddBytes().

## setAlpha()

forcedinline void juce::PixelRGB::setAlpha | ( | uint8 |  | ) |

inline noexcept

This method is included for compatibility with the PixelARGB class.

References forcedinline.

## multiplyAlpha() [1/2]

forcedinline void juce::PixelRGB::multiplyAlpha | ( | int |  | ) |

inline noexcept

Multiplies the colour's alpha value with another one.

References forcedinline.

## multiplyAlpha() [2/2]

forcedinline void juce::PixelRGB::multiplyAlpha | ( | float |  | ) |

inline noexcept

Multiplies the colour's alpha value with another one.

References forcedinline.

## premultiply()

forcedinline void juce::PixelRGB::premultiply | ( |  | ) |

inline noexcept

Premultiplies the pixel's RGB values by its alpha.

References forcedinline.

## unpremultiply()

forcedinline void juce::PixelRGB::unpremultiply | ( |  | ) |

inline noexcept

Unpremultiplies the pixel's RGB values.

References forcedinline.

## desaturate()

forcedinline void juce::PixelRGB::desaturate | ( |  | ) |

inline noexcept

References forcedinline.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited